import os

class SolverStats:
	"""
	Reads solver summary.txt file and provides comparison functionality.
	"""
	
	def __init__(self):
		self.timers = dict()
		self.counters = dict()
		
	def read(self, statsFile):
		"""Attempts to read the summary file and returns True on success.
		
		Parameters
		==========
		
		- *statsFile* File path (relative or absolute) to summary.txt file.
		
		Return value
		============
		True on success, False when file could not be opened or parsed.
		"""
		try:
			fobj = open(statsFile, 'r')
			lines = fobj.readlines()
			for line in lines:
				tokens = line.strip().split("=")
				if len(tokens) != 2:
					continue
				if tokens[0].find("Time") != -1:
					self.timers[tokens[0]] = float(tokens[1])
				else:
					self.counters[tokens[0]] = long(tokens[1])
		except Exception as e:
			print "Error opening/reading file '{}', error: {}".format(statsFile, e)
			return False
		return True

